{Andrew Bednarz 2002}
{bed@abednarz.net}
{http://www.abednarz.net}
unit main;

interface

uses
   Types,SysUtils, Variants, Classes, Graphics, Controls, Forms,
   Dialogs, StdCtrls, BedVersion, LiveJournal, inifiles, ComCtrls,
  ExtCtrls, OleCtrls, DB, DBClient, Grids, DBGrids,
  Buttons, Menus, IdBaseComponent, IdAntiFreezeBase, IdAntiFreeze,
  BedProgressBar;

type
  TMainForm = class(TForm)
    Version: TBedVersion;
    Splitter: TSplitter;
    Panel1: TPanel;
    ProgressBar: TBedProgressBar;
    EventData: TClientDataSet;
    EventSource: TDataSource;
    EventGrid: TDBGrid;
    EventDataID: TIntegerField;
    EventDataWhen: TStringField;
    EventDataMood: TStringField;
    EventDataSubject: TStringField;
    EventDataMusic: TStringField;
    EventDataEvent: TMemoField;
    BottomPanel: TPanel;
    RawMemo: TMemo;
    EventDataSecurity: TStringField;
    MainMenu: TMainMenu;
    Program1: TMenuItem;
    SettingsMenu: TMenuItem;
    Help1: TMenuItem;
    About1: TMenuItem;
    N1: TMenuItem;
    Exit2: TMenuItem;
    BackupMenu: TMenuItem;
    PopupMenu: TPopupMenu;
    ReBackup1: TMenuItem;
    WebView1: TMenuItem;
    ReBackupMenu: TMenuItem;
    HeaderPanel: TPanel;
    Label1: TLabel;
    Label2: TLabel;
    Label4: TLabel;
    Label3: TLabel;
    WhenLabel: TLabel;
    SubjectLabel: TLabel;
    MoodLabel: TLabel;
    MusicLabel: TLabel;
    Label5: TLabel;
    SecurityLabel: TLabel;
    BackupButton: TSpeedButton;
    Label6: TLabel;
    StatusBar: TStatusBar;
    FilterCombo: TComboBox;
    N2: TMenuItem;
    CancelButton: TSpeedButton;
    IdAntiFreeze1: TIdAntiFreeze;
    procedure FormCreate(Sender: TObject);
    procedure FormDestroy(Sender: TObject);
    procedure LoginClick(Sender: TObject);
    procedure BackupButtonClick(Sender: TObject);
    procedure FormActivate(Sender: TObject);
    procedure FormClose(Sender: TObject; var Action: TCloseAction);
    procedure About1Click(Sender: TObject);
    procedure Exit2Click(Sender: TObject);
    procedure SettingsMenuClick(Sender: TObject);
    procedure ReBackup1Click(Sender: TObject);
    procedure ReBackupMenuClick(Sender: TObject);
    procedure WebView1Click(Sender: TObject);
    procedure EventSourceDataChange(Sender: TObject; Field: TField);
    procedure FormShow(Sender: TObject);
    procedure FilterComboChange(Sender: TObject);
    procedure CancelButtonClick(Sender: TObject);
  private
    procedure LoadSettings;
    procedure ViewEntry;
    procedure SaveSettings;
    { Private declarations }
  public
    { Public declarations }
    FirstShow : boolean;
    ini : Tinifile;
    LJ : TLiveJournal;
    LastSync : TDateTime;
    BackupOnStartup : boolean;
    CancelBackup : boolean;
end;

var
    MainForm: TMainForm;

implementation

uses settings, ReBackup,shellapi, find,EncryptIt;

const CRYPTKEY = 39583;

{$R *.dfm}

procedure TMainForm.LoadSettings;
var x : integer;
begin
    LJ.username := ini.readstring('Settings','Username','');
    LJ.password := Decrypt(ini.readstring('Settings','password',''),CRYPTKEY);
    LJ.LastSync := ini.readstring('Settings','lastsync','1900-01-01 24:00:00');
    LJ.MaxMoodID := ini.ReadInteger('Settings','MaxMoodID',0);
    BackupOnStartup := ini.readbool('Settings','BackupOnStartup',false);
    SetLength(LJ.Moods,LJ.MaxMoodID);
    for x:=0 to LJ.MaxMoodID-1 do
    begin
         LJ.Moods[x] := ini.ReadString('Moods',inttostr(x),'');
    end;
    self.caption:='LJBackup ('+version.FileVersion+') - '+LJ.username;
end;

procedure TMainForm.FormCreate(Sender: TObject);
begin
    ini := tinifile.create(extractfilepath(application.exename)+'LJBackup.ini');
    LJ := TLiveJournal.create;
    LJ.clientversion:=version.internalname+'/'+version.FileVersion;
    FirstShow:=true;
    
end;

procedure TMainForm.FormDestroy(Sender: TObject);
begin
    LJ.free;
    ini.free;
end;

procedure TMainForm.LoginClick(Sender: TObject);
begin
    screen.Cursor:=crHourGlass;
    try
        if not LJ.Login then
        begin
            statusbar.SimpleText:='Login Error:' + LJ.GetLastError;
        end else begin
            statusbar.SimpleText:='Login OK';
        end;
    finally
        screen.Cursor:=crDefault;
    end;
end;
procedure TMainForm.BackupButtonClick(Sender: TObject);
var SyncItems : TSyncItemsResult;
    Events : TGetEventsResult;
    x,y : integer;
    ListItem : TListItem;
    Error : boolean;
begin
    Error:=false;
    screen.Cursor:=crAppStart;
    BackupButton.Enabled:=false;
    BackupMenu.enabled:=false;
    ReBackupMenu.enabled:=false;
    FilterCombo.enabled:=false;
    SettingsMenu.enabled:=false;
    ProgressBar.LeftPos:=0;
    ProgressBar.Max:=0;
    ProgressBar.Visible:=true;
    CancelButton.visible:=true;
    statusbar.SimpleText:='Logging in...';
    application.ProcessMessages;
    if not LJ.Login then
    begin
         statusbar.SimpleText:='Login() Error:' + LJ.GetLastError;
         exit;
    end;
    statusbar.SimpleText:='Getting Record count...';
    application.ProcessMessages;
    try
       CancelBackup:=false;
       repeat
         SyncItems := LJ.SyncItems;
         if SyncItems = nil then
         begin
              statusbar.SimpleText:='SyncItems() Error:' + LJ.GetLastError;
              Error:=true;
         end else begin
             if ProgressBar.Max=0 then ProgressBar.Max:=SyncItems.total;
             for y:=0 to SyncItems.items.Count-1 do
             begin
                  if CancelBackup then break;
                  statusbar.SimpleText:='Retreiving '+inttostr(y+1)+'/'+inttostr(SyncItems.total)+' entries...';
                  application.ProcessMessages;

                  Events := LJ.GetEvents(TSyncItem(SyncItems.items.Items[y]).itemID);
                  if Events=nil then
                  begin
                       statusbar.SimpleText:='GetEvents() Error:' + LJ.GetLastError;
                       Error:=true;
                  end else begin
                      for x:=0 to Events.events.count-1 do
                      begin
                         ProgressBar.LeftPos:=ProgressBar.LeftPos+1;
                         EventData.First;
                         if EventData.Locate('id',TLJEvent(events.events.Items[x]).itemID,[]) then EventData.edit
                            else EventData.append;
                         EventData['id']:=TLJEvent(events.events.Items[x]).itemID;
                         EventData['when']:=TLJEvent(events.events.Items[x]).EventTime;
                         EventData['subject']:=TLJEvent(events.events.Items[x]).Subject;
                         EventData['mood']:=TLJEvent(events.events.Items[x]).mood;
                         EventData['music']:=TLJEvent(events.events.Items[x]).Music;
                         EventData['event']:=TLJEvent(events.events.Items[x]).Event;
                         EventData['security']:=TLJEvent(events.events.Items[x]).Security;
                         EventData.post;
                         if EventData.RecNo=1 then LJ.LastSync := EventData['when'];
                      end;
                 end;
             end;
         end;
         if CancelBackup then break;
       until (SyncItems = nil) or (SyncItems.count=SyncItems.total);
       if not Error then
       begin
            EventData.first;
            statusbar.SimpleText:='Last Update: '+LJ.LastSync;
       end;
    finally
       ProgressBar.Visible:=false;
       screen.Cursor:=crDefault;
       BackupButton.Enabled:=true;
       BackupMenu.enabled:=true;
       CancelButton.visible:=false;
       ReBackupMenu.enabled:=true;
       FilterCombo.enabled:=true;
       SettingsMenu.enabled:=true;
    end;
end;

procedure TMainForm.ViewEntry;
begin
     if not VarisNull(EventData['event']) then RawMemo.lines.Text := EventData['event'] else RawMemo.lines.Text:='...';
     if not VarisNull(EventData['when']) then WhenLabel.Caption := EventData['when'] else WhenLabel.caption:='...';
     if not VarisNull(EventData['subject']) then SubjectLabel.caption:= EventData['subject'] else Subjectlabel.caption:='...';
     if not VarisNull(EventData['mood']) then MoodLabel.caption:= EventData['mood'] else MoodLabel.caption:='...';
     if not VarisNull(EventData['music']) then MusicLabel.caption := EventData['music'] else MusicLabel.caption:='...';
     if not VarisNull(EventData['security']) then SecurityLabel.caption := EventData['security'] else SecurityLabel.caption:='...';
end;

procedure TMainForm.FormActivate(Sender: TObject);
begin
     if FirstShow then
     begin
          LoadSettings;
          if LJ.Username='' then SettingsMenu.Click;
          Screen.cursor:=crHourGlass;
          statusbar.SimpleText:='Loading Entries...';
          application.ProcessMessages;
          EventData.FileName:=extractfilepath(application.exename)+'Entries.xml';
          if not FileExists(EventData.FileName) then
          begin
               EventData.CreateDataSet;
          end;
          EventData.Open;
          EventData.AddIndex('Date','When',[ixPrimary,ixDescending]);
          EventData.IndexName:='Date';
          EventData.LogChanges:=false;
          EventData.First;
          statusbar.SimpleText:='Last Update: '+LJ.LastSync;
          Screen.cursor:=crDefault;
          if BackupOnStartup then BackupButton.click;
          FirstShow:=false;
     end;
end;

procedure TMainForm.FormClose(Sender: TObject; var Action: TCloseAction);
begin
     Screen.cursor:=crHourGlass;
     statusbar.SimpleText:='Saving Entries...';
     application.ProcessMessages;
     EventData.Close;
     SaveSettings;
     Screen.cursor:=crDefault;
end;

procedure TMainForm.SaveSettings;
var x : integer;
begin
    ini.WriteString('Settings','Username',LJ.username);
    ini.WriteString('Settings','password',Encrypt(LJ.password,CRYPTKEY));
    ini.WriteString('Settings','lastsync',LJ.LastSync);
    ini.writebool('Settings','BackupOnStartup',BackupOnStartup);
    ini.WriteInteger('Settings','MaxMoodID',LJ.MaxMoodID);
    for x:=0 to LJ.MaxMoodID-1 do
    begin
         ini.WriteString('Moods',inttostr(x),LJ.Moods[x]);
    end;
end;
procedure TMainForm.About1Click(Sender: TObject);
begin
     MessageDlg(self.caption+#13+#10+'Freeware'+#13+#10+'(c) 2002 Andrew Bednarz'+#13+#10+'http://www.abednarz.net', mtInformation, [mbOK], 0);
end;

procedure TMainForm.Exit2Click(Sender: TObject);
begin
     close;
end;

procedure TMainForm.SettingsMenuClick(Sender: TObject);
begin
     SettingsForm.UsernameEdit.text:=LJ.username;
     SettingsForm.PasswordEdit.text:=LJ.password;
     SettingsForm.BOSCheck.Checked := BackupOnStartup;
     if SettingsForm.ShowModal=mrok then
     begin
          LJ.username:=SettingsForm.UsernameEdit.text;
          LJ.password:=SettingsForm.PasswordEdit.text;
          BackupOnStartup:=SettingsForm.BOSCheck.Checked;
     end;
end;

procedure TMainForm.ReBackup1Click(Sender: TObject);
var Events : TGetEventsResult;
begin
      screen.cursor:=crAppStart;
      statusbar.SimpleText:='Re-Backing up entry '+inttostr(EventData['id'])+'...';
      application.ProcessMessages;
      Events := LJ.GetEvents(EventData['id']);
      if Events=nil then
      begin
           statusbar.SimpleText:='GetEvents() Error:' + LJ.GetLastError;
           exit;
      end else begin
           EventData.edit;
           EventData['id']:=TLJEvent(events.events.Items[0]).itemID;
           EventData['when']:=TLJEvent(events.events.Items[0]).EventTime;
           EventData['subject']:=TLJEvent(events.events.Items[0]).Subject;
           EventData['mood']:=TLJEvent(events.events.Items[0]).mood;
           EventData['music']:=TLJEvent(events.events.Items[0]).Music;
           EventData['event']:=TLJEvent(events.events.Items[0]).Event;
           EventData['security']:=TLJEvent(events.events.Items[0]).Security;
           EventData.post;
     end;
     screen.cursor:=crDefault;
     statusbar.SimpleText:='Last Update: '+LJ.LastSync;
end;

procedure TMainForm.ReBackupMenuClick(Sender: TObject);
begin
     DateForm.Caption:='Re-Backup';
     DateForm.InfoLabel.caption:='Select date to re-backup from:';
     if DateForm.showmodal=mrOK then
     begin
          LJ.LastSync:=formatdatetime('yyyy-mm-dd hh:nn:ss',DateForm.DateEdit.datetime);
          BackupButton.Click;
     end;
end;

procedure TMainForm.WebView1Click(Sender: TObject);
var tf : textfile;
    filename, s1,s2 :string;
    x : integer;
begin
     Filename:=extractfilepath(application.exename)+'viewentry.html';
     //html file
     assignfile(tf,filename);
     rewrite(tf);
     s1:=EventData['event'];
     s2:='';
     for x:=1 to length(s1) do
     begin
          if s1[x]=#10 then s2:=s2+'<BR>' else s2:=s2+s1[x];
     end;
     writeln(tf,'<HTML><HEAD><TITLE>LJBackup</TITLE><HEAD><BODY>');
     writeln(tf,'<b>When: </b>'+EventData['when']+'<BR>');
     writeln(tf,'<b>Subject: </b>'+EventData['subject']+'<BR>');
     writeln(tf,'<b>Security: </b>'+EventData['security']+'<BR>');
     writeln(tf,'<b>Mood: </b>'+EventData['mood']+'<BR>');
     writeln(tf,'<b>Music: </b>'+EventData['music']+'<BR>');
     writeln(tf,'<p>');
     writeln(tf,s2);
     writeln(tf,'</p></BODY><HTML>');
     closefile(tf);
     ShellExecute(self.Handle,'open',pchar(filename),'','',0);
end;

procedure TMainForm.EventSourceDataChange(Sender: TObject; Field: TField);
begin
     ViewEntry;
end;

procedure TMainForm.FormShow(Sender: TObject);
begin
    RawMemo.SetFocus;
end;

procedure TMainForm.FilterComboChange(Sender: TObject);
var Cancel : boolean;
    field : string;
begin
    Cancel:=false;
    if FilterCombo.Text='<None>' then
    begin
        Cancel:=true;
    end else if FilterCombo.Text='When' then
    begin
        DateForm.Caption:='Filter';
        DateForm.InfoLabel.caption:='Select date to display:';
        if DateForm.showmodal=mrOK then
        begin
            EventData.filter:='when like '''+formatdatetime('yyyy-mm-dd',DateForm.DateEdit.date)+'%''';
            EventData.filtered:=true;
            StatusBar.SimpleText:='Filtered: When = '+formatdatetime('yyyy-mm-dd',DateForm.DateEdit.date);
        end else Cancel:=true;
    end else begin
        FindForm.Caption:='Filter';
        if FilterCombo.text='Entry' then field:='Event' else field:=FilterCombo.text;
        FindForm.InfoLabel.caption:=FilterCombo.text+' contains:';
        if FindForm.showmodal=mrok then
        begin
            EventData.filter:=field +' like ''%'+FindForm.FindEdit.text+'%''';
            EventData.filtered:=true;
            StatusBar.SimpleText:='Filtered: '+FilterCombo.text+' contains "'+FindForm.FindEdit.text+'"';
        end else Cancel:=true;
    end;
    if Cancel then
    begin
        EventData.Filter:='';
        EventData.Filtered:=false;
        StatusBar.SimpleText:='Last Update: '+LJ.LastSync;
        FilterCombo.ItemIndex:=FilterCombo.Items.IndexOf('<None>');
    end;
end;

procedure TMainForm.CancelButtonClick(Sender: TObject);
begin
    CancelBackup:=true;
end;

end.
